package com.nhbc.pda.sql;

import java.sql.PreparedStatement;
import java.sql.ResultSet;
import com.nhbc.pda.depthCalc.Constants;

/**
 *  A class for connecting to a database.
 *
 */
public class Connect{

  private java.sql.Connection  connection = null;
  private final String URL = Constants.DB_URL ;
  private final String DRIVER = Constants.DB_DRIVER;
  private final String SERVERNAME= Constants.DB_SERVERNAME;
  private final String PORTNUMBER = Constants.DB_PORTNUMBER;
  private final String DATABASENAME= Constants.DB_DATABASENAME;
  private final String USERNAME = Constants.DB_USERNAME;
  private final String PASSWORD = Constants.DB_PASSWORD;
     
  /**
   *  Informs the driver to use server a side-cursor, 
   *  which permits more than one active statement 
   *  on a connection.
   */
  private final String SELECTMETHOD = "cursor"; 
   
  /**
  * Build the connection url
  * @return  String 
  */
  private String getConnectionUrl()
  {
    return URL+SERVERNAME+":"+PORTNUMBER+";databaseName="+DATABASENAME+";selectMethod="+SELECTMETHOD+";";
  }
   
  /**
  * load and return the connection to the database.
  * @return  connection 
  */
  public java.sql.Connection getConnection()
  {
   try
   {
    // changed from "Class.forName(DRIVER); " Needs testing
     Class.forName(DRIVER, true, this.getClass().getClassLoader()); 
     connection = java.sql.DriverManager.getConnection(getConnectionUrl(),USERNAME,PASSWORD);
   } catch(Exception e)
   {
     System.out.println("Error in Connect.getConnection() : " + e.getMessage());
     System.out.println("Application Exit()");
     System.out.close();
   }
  return connection;
  }
  
  /**
  * Close the connection.
  */ 
  public void closeConnection()
  {
    try{
      if(connection!=null)
        connection.close();
        connection=null;
    } catch(Exception e){
        e.printStackTrace();
    }
   }
 }
